#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include "db_connection.h"

void vis(float p)
{
  const int Width = 50;
  int done = (int)(Width * p);

  putchar('[');
  for (int i = 0; i < Width; i++) {
    if(i < done)
      putchar('=');
    else
      putchar('.');
  }
  printf("] %.3f %%\n", (p*100));
}


int main(int argc, char** argv)
{
  const unsigned long totalExps = (1UL<<__INT/2)-1;

  printf("Countdown for table: %s\n", g_db_table);

  if( db_connect() != DBOK ) {
    exit(1);
  }

  // Test if table exists
  if(db_table_exists(g_db_table)){
    int rows = db_table_rowcount(g_db_table);
    if( rows == DBERR ) {
      exit(1);
    }

    printf("Finished %d of %lu As\n", rows, totalExps);
    vis((float)(rows) / (float)(totalExps));
  }

  db_close();
  return 0;
}

