#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <stdint.h>

/*
            Configuration
   ---------------------------------
   Setup simulation parameters here!
   vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
 */

#define __INT 32
#define __FAULTS 8
#define __DOCHECK

/*
   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
         End of configuration
   ----------------------------------

   All configuration is done above.
   DO NOT CHANGE ANYTHING BELOW THIS LINE!
 */

// Static maximal string size for SQL queries
#define QUERYSIZE 2048

#ifndef __A
#define __A 239
#endif

#ifdef __DOCHECK
#define __CHECK check
#else
#define __CHECK NOcheck
#endif

// The sql table name of the current campaign
extern const char* g_db_table;


// Datatypes
#if __INT == 16
	#define __MAX_ENC UINT16_MAX
	#define __MAX_PLAIN UINT8_MAX
	#define __POPCOUNT(value) __builtin_popcount(value)
	typedef uint_fast16_t enc_t;
	typedef uint_fast8_t plain_t;
	typedef uint_fast64_t experiments_t;
	typedef plain_t A_t;
	#define PRINTPLN "%u"
	#define PRINTENC "%u"
	#define PRINTEXP "%lu"
#endif

#if __INT == 32
	#define __MAX_ENC UINT32_MAX
	#define __MAX_PLAIN UINT16_MAX
	#define __POPCOUNT(value) __builtin_popcount(value)
	typedef uint_fast32_t enc_t;
	typedef uint_fast16_t plain_t;
	typedef uint_fast64_t experiments_t;
	typedef plain_t A_t;
	#define PRINTPLN "%lu"
	#define PRINTENC "%u"
	#define PRINTEXP "%lu"
#endif

#if __INT == 64
	#define __MAX_ENC UINT64_MAX
	#define __MAX_PLAIN UINT32_MAX
	#define __POPCOUNT(value) __builtin_popcountl(value)
	typedef uint_fast64_t enc_t;
	typedef uint_fast32_t plain_t;
	typedef uint_fast64_t experiments_t;
	typedef plain_t A_t;
	#define PRINTPLN "%lu"
	#define PRINTENC "%llu"
	#define PRINTEXP "%lu"
#endif

typedef struct {
  experiments_t sum;
  experiments_t due;
  experiments_t sdc;
  experiments_t ovf;
  experiments_t patterns;
} result_t;



#endif // __CONFIG_H__

